#include "AIOUSB.h"

HANDLE hDLL = NULL;

unsigned long AIOUSB_Load(void)
{
	if ( hDLL ) AIOUSB_Unload();

	hDLL = LoadLibrary("AIOUSB.dll");
	if ( ! hDLL ) return ERROR_OPEN_FAILED; //LoadLibrary sets last error.

	ULONG ProcStatus = ERROR_SUCCESS;

	GetDevices = (void *)(GetProcAddress(hDLL, "GetDevices"));
	if ( ! GetDevices ) ProcStatus = ERROR_INVALID_FUNCTION;
	QueryDeviceInfo = (void *)(GetProcAddress(hDLL, "QueryDeviceInfo"));
	if ( ! QueryDeviceInfo ) ProcStatus = ERROR_INVALID_FUNCTION;
	AIOUSB_CloseDevice = (void *)(GetProcAddress(hDLL, "AIOUSB_CloseDevice"));
	if ( ! AIOUSB_CloseDevice ) ProcStatus = ERROR_INVALID_FUNCTION;
	ClearDevices = (void *)(GetProcAddress(hDLL, "ClearDevices"));
	if ( ! ClearDevices ) ProcStatus = ERROR_INVALID_FUNCTION;
	GetDeviceUniqueStr = (void *)(GetProcAddress(hDLL, "GetDeviceUniqueStr"));
	if ( ! GetDeviceUniqueStr ) ProcStatus = ERROR_INVALID_FUNCTION;
	GetDeviceSerialNumber = (void *)(GetProcAddress(hDLL, "GetDeviceSerialNumber"));
	if ( ! GetDeviceSerialNumber ) ProcStatus = ERROR_INVALID_FUNCTION;
	ResolveDeviceIndex = (void *)(GetProcAddress(hDLL, "ResolveDeviceIndex"));
	if ( ! ResolveDeviceIndex ) ProcStatus = ERROR_INVALID_FUNCTION;
	GetDeviceByEEPROMByte = (void *)(GetProcAddress(hDLL, "GetDeviceByEEPROMByte"));
	if ( ! GetDeviceByEEPROMByte ) ProcStatus = ERROR_INVALID_FUNCTION;
	GetDeviceByEEPROMData = (void *)(GetProcAddress(hDLL, "GetDeviceByEEPROMData"));
	if ( ! GetDeviceByEEPROMData ) ProcStatus = ERROR_INVALID_FUNCTION;
	GetDeviceBySerialNumber = (void *)(GetProcAddress(hDLL, "GetDeviceBySerialNumber"));
	if ( ! GetDeviceBySerialNumber ) ProcStatus = ERROR_INVALID_FUNCTION;

	AIOUSB_ClearFIFO = (void *)(GetProcAddress(hDLL, "AIOUSB_ClearFIFO"));
	if ( ! AIOUSB_ClearFIFO ) ProcStatus = ERROR_INVALID_FUNCTION;
	AIOUSB_GetStreamStatus = (void *)(GetProcAddress(hDLL, "AIOUSB_GetStreamStatus"));
	if ( ! AIOUSB_GetStreamStatus ) ProcStatus = ERROR_INVALID_FUNCTION;
	AIOUSB_SetStreamingBlockSize = (void *)(GetProcAddress(hDLL, "AIOUSB_SetStreamingBlockSize"));
	if ( ! AIOUSB_SetStreamingBlockSize ) ProcStatus = ERROR_INVALID_FUNCTION;
	AIOUSB_ResetChip = (void *)(GetProcAddress(hDLL, "AIOUSB_ResetChip"));
	if ( ! AIOUSB_ResetChip ) ProcStatus = ERROR_INVALID_FUNCTION;
	AIOUSB_ReloadDeviceLinks = (void *)(GetProcAddress(hDLL, "AIOUSB_ReloadDeviceLinks"));
	if ( ! AIOUSB_ReloadDeviceLinks ) ProcStatus = ERROR_INVALID_FUNCTION;
	AIOUSB_UploadD15LoFirmwaresByPID = (void *)(GetProcAddress(hDLL, "AIOUSB_UploadD15LoFirmwaresByPID"));
	if ( ! AIOUSB_UploadD15LoFirmwaresByPID ) ProcStatus = ERROR_INVALID_FUNCTION;

	AIOUSB_QuerySimplePNPData = (void *)(GetProcAddress(hDLL, "AIOUSB_QuerySimplePNPData"));
	if ( ! AIOUSB_QuerySimplePNPData ) ProcStatus = ERROR_INVALID_FUNCTION;

	CustomEEPROMRead = (void *)(GetProcAddress(hDLL, "CustomEEPROMRead"));
	if ( ! CustomEEPROMRead ) ProcStatus = ERROR_INVALID_FUNCTION;
	CustomEEPROMWrite = (void *)(GetProcAddress(hDLL, "CustomEEPROMWrite"));
	if ( ! CustomEEPROMWrite ) ProcStatus = ERROR_INVALID_FUNCTION;
	AIOUSB_FlashRead = (void *)(GetProcAddress(hDLL, "AIOUSB_FlashRead"));
	if ( ! AIOUSB_FlashRead ) ProcStatus = ERROR_INVALID_FUNCTION;
	AIOUSB_FlashWrite = (void *)(GetProcAddress(hDLL, "AIOUSB_FlashWrite"));
	if ( ! AIOUSB_FlashWrite ) ProcStatus = ERROR_INVALID_FUNCTION;
	AIOUSB_FlashEraseSector = (void *)(GetProcAddress(hDLL, "AIOUSB_FlashEraseSector"));
	if ( ! AIOUSB_FlashEraseSector ) ProcStatus = ERROR_INVALID_FUNCTION;

	GenericVendorRead = (void *)(GetProcAddress(hDLL, "GenericVendorRead"));
	if ( ! GenericVendorRead ) ProcStatus = ERROR_INVALID_FUNCTION;
	GenericVendorWrite = (void *)(GetProcAddress(hDLL, "GenericVendorWrite"));
	if ( ! GenericVendorWrite ) ProcStatus = ERROR_INVALID_FUNCTION;
	AWU_GenericBulkIn = (void *)(GetProcAddress(hDLL, "AWU_GenericBulkIn"));
	if ( ! AWU_GenericBulkIn ) ProcStatus = ERROR_INVALID_FUNCTION;
	AWU_GenericBulkOut = (void *)(GetProcAddress(hDLL, "AWU_GenericBulkOut"));
	if ( ! AWU_GenericBulkOut ) ProcStatus = ERROR_INVALID_FUNCTION;



	ADC_GetScan = (void *)(GetProcAddress(hDLL, "ADC_GetScan"));
	if ( ! ADC_GetScan ) ProcStatus = ERROR_INVALID_FUNCTION;
	ADC_GetScanV = (void *)(GetProcAddress(hDLL, "ADC_GetScanV"));
	if ( ! ADC_GetScanV ) ProcStatus = ERROR_INVALID_FUNCTION;
	ADC_GetChannelV = (void *)(GetProcAddress(hDLL, "ADC_GetChannelV"));
	if ( ! ADC_GetChannelV ) ProcStatus = ERROR_INVALID_FUNCTION;
	ADC_GetCalRefV = (void *)(GetProcAddress(hDLL, "ADC_GetCalRefV"));
	if ( ! ADC_GetCalRefV ) ProcStatus = ERROR_INVALID_FUNCTION;

	ADC_GetTrigScan = (void *)(GetProcAddress(hDLL, "ADC_GetTrigScan"));
	if ( ! ADC_GetTrigScan ) ProcStatus = ERROR_INVALID_FUNCTION;
	ADC_GetTrigScanV = (void *)(GetProcAddress(hDLL, "ADC_GetTrigScanV"));
	if ( ! ADC_GetTrigScanV ) ProcStatus = ERROR_INVALID_FUNCTION;

	ADC_GetConfig = (void *)(GetProcAddress(hDLL, "ADC_GetConfig"));
	if ( ! ADC_GetConfig ) ProcStatus = ERROR_INVALID_FUNCTION;
	ADC_SetConfig = (void *)(GetProcAddress(hDLL, "ADC_SetConfig"));
	if ( ! ADC_SetConfig ) ProcStatus = ERROR_INVALID_FUNCTION;
	ADC_ADMode = (void *)(GetProcAddress(hDLL, "ADC_ADMode"));
	if ( ! ADC_ADMode ) ProcStatus = ERROR_INVALID_FUNCTION;
	ADC_Range1 = (void *)(GetProcAddress(hDLL, "ADC_Range1"));
	if ( ! ADC_Range1 ) ProcStatus = ERROR_INVALID_FUNCTION;
	ADC_RangeAll = (void *)(GetProcAddress(hDLL, "ADC_RangeAll"));
	if ( ! ADC_RangeAll ) ProcStatus = ERROR_INVALID_FUNCTION;
	ADC_SetScanLimits = (void *)(GetProcAddress(hDLL, "ADC_SetScanLimits"));
	if ( ! ADC_SetScanLimits ) ProcStatus = ERROR_INVALID_FUNCTION;
	ADC_SetOversample = (void *)(GetProcAddress(hDLL, "ADC_SetOversample"));
	if ( ! ADC_SetOversample ) ProcStatus = ERROR_INVALID_FUNCTION;
	ADC_QueryCal = (void *)(GetProcAddress(hDLL, "ADC_QueryCal"));
	if ( ! ADC_QueryCal ) ProcStatus = ERROR_INVALID_FUNCTION;
	ADC_SetCal = (void *)(GetProcAddress(hDLL, "ADC_SetCal"));
	if ( ! ADC_SetCal ) ProcStatus = ERROR_INVALID_FUNCTION;
	ADC_SetCalAndSave = (void *)(GetProcAddress(hDLL, "ADC_SetCalAndSave"));
	if ( ! ADC_SetCalAndSave ) ProcStatus = ERROR_INVALID_FUNCTION;
	ADC_Initialize = (void *)(GetProcAddress(hDLL, "ADC_Initialize"));
	if ( ! ADC_Initialize ) ProcStatus = ERROR_INVALID_FUNCTION;
	ADC_GetImmediate = (void *)(GetProcAddress(hDLL, "ADC_GetImmediate"));
	if ( ! ADC_GetImmediate ) ProcStatus = ERROR_INVALID_FUNCTION;

	ADC_BulkAcquire = (void *)(GetProcAddress(hDLL, "ADC_BulkAcquire"));
	if ( ! ADC_BulkAcquire ) ProcStatus = ERROR_INVALID_FUNCTION;
	ADC_BulkPoll = (void *)(GetProcAddress(hDLL, "ADC_BulkPoll"));
	if ( ! ADC_BulkPoll ) ProcStatus = ERROR_INVALID_FUNCTION;
	ADC_BulkAbort = (void *)(GetProcAddress(hDLL, "ADC_BulkAbort"));
	if ( ! ADC_BulkAbort ) ProcStatus = ERROR_INVALID_FUNCTION;

	ADC_BulkMode = (void *)(GetProcAddress(hDLL, "ADC_BulkMode"));
	if ( ! ADC_BulkMode ) ProcStatus = ERROR_INVALID_FUNCTION;
	ADC_BulkContinuousCallbackStart = (void *)(GetProcAddress(hDLL, "ADC_BulkContinuousCallbackStart"));
	if ( ! ADC_BulkContinuousCallbackStart ) ProcStatus = ERROR_INVALID_FUNCTION;
	ADC_BulkContinuousCallbackStartClocked = (void *)(GetProcAddress(hDLL, "ADC_BulkContinuousCallbackStartClocked"));
	if ( ! ADC_BulkContinuousCallbackStartClocked ) ProcStatus = ERROR_INVALID_FUNCTION;
	ADC_BulkContinuousRingStart = (void *)(GetProcAddress(hDLL, "ADC_BulkContinuousRingStart"));
	if ( ! ADC_BulkContinuousRingStart ) ProcStatus = ERROR_INVALID_FUNCTION;
	ADC_BulkContinuousEnd = (void *)(GetProcAddress(hDLL, "ADC_BulkContinuousEnd"));
	if ( ! ADC_BulkContinuousEnd ) ProcStatus = ERROR_INVALID_FUNCTION;

	ADC_FullStartRing = (void *)(GetProcAddress(hDLL, "ADC_FullStartRing"));
	if ( ! ADC_FullStartRing ) ProcStatus = ERROR_INVALID_FUNCTION;
	ADC_ReadData = (void *)(GetProcAddress(hDLL, "ADC_ReadData"));
	if ( ! ADC_ReadData ) ProcStatus = ERROR_INVALID_FUNCTION;

	ADC_InitFastITScanV = (void *)(GetProcAddress(hDLL, "ADC_InitFastITScanV"));
	if ( ! ADC_InitFastITScanV ) ProcStatus = ERROR_INVALID_FUNCTION;
	ADC_ResetFastITScanV = (void *)(GetProcAddress(hDLL, "ADC_ResetFastITScanV"));
	if ( ! ADC_ResetFastITScanV ) ProcStatus = ERROR_INVALID_FUNCTION;
	ADC_SetFastITScanVChannels = (void *)(GetProcAddress(hDLL, "ADC_SetFastITScanVChannels"));
	if ( ! ADC_SetFastITScanVChannels ) ProcStatus = ERROR_INVALID_FUNCTION;
	ADC_GetFastITScanV = (void *)(GetProcAddress(hDLL, "ADC_GetFastITScanV"));
	if ( ! ADC_GetFastITScanV ) ProcStatus = ERROR_INVALID_FUNCTION;
	ADC_GetITScanV = (void *)(GetProcAddress(hDLL, "ADC_GetITScanV"));
	if ( ! ADC_GetITScanV ) ProcStatus = ERROR_INVALID_FUNCTION;

	ADC_InitFastScanV = (void *)(GetProcAddress(hDLL, "ADC_InitFastScanV"));
	if ( ! ADC_InitFastScanV ) ProcStatus = ERROR_INVALID_FUNCTION;
	ADC_ResetFastScanV = (void *)(GetProcAddress(hDLL, "ADC_ResetFastScanV"));
	if ( ! ADC_ResetFastScanV ) ProcStatus = ERROR_INVALID_FUNCTION;
	ADC_GetFastScanV = (void *)(GetProcAddress(hDLL, "ADC_GetFastScanV"));
	if ( ! ADC_GetFastScanV ) ProcStatus = ERROR_INVALID_FUNCTION;



	CTR_8254Load = (void *)(GetProcAddress(hDLL, "CTR_8254Load"));
	if ( ! CTR_8254Load ) ProcStatus = ERROR_INVALID_FUNCTION;
	CTR_8254Mode = (void *)(GetProcAddress(hDLL, "CTR_8254Mode"));
	if ( ! CTR_8254Mode ) ProcStatus = ERROR_INVALID_FUNCTION;
	CTR_8254ModeLoad = (void *)(GetProcAddress(hDLL, "CTR_8254ModeLoad"));
	if ( ! CTR_8254ModeLoad ) ProcStatus = ERROR_INVALID_FUNCTION;
	CTR_8254Read = (void *)(GetProcAddress(hDLL, "CTR_8254Read"));
	if ( ! CTR_8254Read ) ProcStatus = ERROR_INVALID_FUNCTION;
	CTR_8254ReadStatus = (void *)(GetProcAddress(hDLL, "CTR_8254ReadStatus"));
	if ( ! CTR_8254ReadStatus ) ProcStatus = ERROR_INVALID_FUNCTION;
	CTR_8254ReadModeLoad = (void *)(GetProcAddress(hDLL, "CTR_8254ReadModeLoad"));
	if ( ! CTR_8254ReadModeLoad ) ProcStatus = ERROR_INVALID_FUNCTION;

	CTR_StartOutputFreq = (void *)(GetProcAddress(hDLL, "CTR_StartOutputFreq"));
	if ( ! CTR_StartOutputFreq ) ProcStatus = ERROR_INVALID_FUNCTION;

	CTR_8254ReadAll = (void *)(GetProcAddress(hDLL, "CTR_8254ReadAll"));
	if ( ! CTR_8254ReadAll ) ProcStatus = ERROR_INVALID_FUNCTION;

	CTR_8254SelectGate = (void *)(GetProcAddress(hDLL, "CTR_8254SelectGate"));
	if ( ! CTR_8254SelectGate ) ProcStatus = ERROR_INVALID_FUNCTION;
	CTR_8254ReadLatched = (void *)(GetProcAddress(hDLL, "CTR_8254ReadLatched"));
	if ( ! CTR_8254ReadLatched ) ProcStatus = ERROR_INVALID_FUNCTION;
	CTR_SetWaitGates = (void *)(GetProcAddress(hDLL, "CTR_SetWaitGates"));
	if ( ! CTR_SetWaitGates ) ProcStatus = ERROR_INVALID_FUNCTION;
	CTR_EndWaitGates = (void *)(GetProcAddress(hDLL, "CTR_EndWaitGates"));
	if ( ! CTR_EndWaitGates ) ProcStatus = ERROR_INVALID_FUNCTION;
	CTR_WaitForGate = (void *)(GetProcAddress(hDLL, "CTR_WaitForGate"));
	if ( ! CTR_WaitForGate ) ProcStatus = ERROR_INVALID_FUNCTION;

	CTR_StartMeasuringPulseWidth = (void *)(GetProcAddress(hDLL, "CTR_StartMeasuringPulseWidth"));
	if ( ! CTR_StartMeasuringPulseWidth ) ProcStatus = ERROR_INVALID_FUNCTION;
	CTR_StopMeasuringPulseWidth = (void *)(GetProcAddress(hDLL, "CTR_StopMeasuringPulseWidth"));
	if ( ! CTR_StopMeasuringPulseWidth ) ProcStatus = ERROR_INVALID_FUNCTION;
	CTR_GetPulseWidthMeasurement = (void *)(GetProcAddress(hDLL, "CTR_GetPulseWidthMeasurement"));
	if ( ! CTR_GetPulseWidthMeasurement ) ProcStatus = ERROR_INVALID_FUNCTION;



	DIO_Configure = (void *)(GetProcAddress(hDLL, "DIO_Configure"));
	if ( ! DIO_Configure ) ProcStatus = ERROR_INVALID_FUNCTION;
	DIO_ConfigureEx = (void *)(GetProcAddress(hDLL, "DIO_ConfigureEx"));
	if ( ! DIO_ConfigureEx ) ProcStatus = ERROR_INVALID_FUNCTION;
	DIO_ConfigureMasked = (void *)(GetProcAddress(hDLL, "DIO_ConfigureMasked"));
	if ( ! DIO_ConfigureMasked ) ProcStatus = ERROR_INVALID_FUNCTION;
	DIO_ConfigurationQuery = (void *)(GetProcAddress(hDLL, "DIO_ConfigurationQuery"));
	if ( ! DIO_ConfigurationQuery ) ProcStatus = ERROR_INVALID_FUNCTION;

	DIO_Read1 = (void *)(GetProcAddress(hDLL, "DIO_Read1"));
	if ( ! DIO_Read1 ) ProcStatus = ERROR_INVALID_FUNCTION;
	DIO_Read8 = (void *)(GetProcAddress(hDLL, "DIO_Read8"));
	if ( ! DIO_Read8 ) ProcStatus = ERROR_INVALID_FUNCTION;
	DIO_ReadAll = (void *)(GetProcAddress(hDLL, "DIO_ReadAll"));
	if ( ! DIO_ReadAll ) ProcStatus = ERROR_INVALID_FUNCTION;

	DIO_Write1 = (void *)(GetProcAddress(hDLL, "DIO_Write1"));
	if ( ! DIO_Write1 ) ProcStatus = ERROR_INVALID_FUNCTION;
	DIO_Write8 = (void *)(GetProcAddress(hDLL, "DIO_Write8"));
	if ( ! DIO_Write8 ) ProcStatus = ERROR_INVALID_FUNCTION;
	DIO_WriteAll = (void *)(GetProcAddress(hDLL, "DIO_WriteAll"));
	if ( ! DIO_WriteAll ) ProcStatus = ERROR_INVALID_FUNCTION;



	DIO_StreamOpen = (void *)(GetProcAddress(hDLL, "DIO_StreamOpen"));
	if ( ! DIO_StreamOpen ) ProcStatus = ERROR_INVALID_FUNCTION;
	DIO_StreamClose = (void *)(GetProcAddress(hDLL, "DIO_StreamClose"));
	if ( ! DIO_StreamClose ) ProcStatus = ERROR_INVALID_FUNCTION;
	DIO_StreamFrame = (void *)(GetProcAddress(hDLL, "DIO_StreamFrame"));
	if ( ! DIO_StreamFrame ) ProcStatus = ERROR_INVALID_FUNCTION;
	DIO_StreamSetClocks = (void *)(GetProcAddress(hDLL, "DIO_StreamSetClocks"));
	if ( ! DIO_StreamSetClocks ) ProcStatus = ERROR_INVALID_FUNCTION;

	DIO_SPI_Read = (void *)(GetProcAddress(hDLL, "DIO_SPI_Read"));
	if ( ! DIO_SPI_Read ) ProcStatus = ERROR_INVALID_FUNCTION;
	DIO_SPI_Write = (void *)(GetProcAddress(hDLL, "DIO_SPI_Write"));
	if ( ! DIO_SPI_Write ) ProcStatus = ERROR_INVALID_FUNCTION;

	DIO_CSA_DoSync = (void *)(GetProcAddress(hDLL, "DIO_CSA_DoSync"));
	if ( ! DIO_CSA_DoSync ) ProcStatus = ERROR_INVALID_FUNCTION;
	DIO_CSA_DebounceSet = (void *)(GetProcAddress(hDLL, "DIO_CSA_DebounceSet"));
	if ( ! DIO_CSA_DebounceSet ) ProcStatus = ERROR_INVALID_FUNCTION;
	DIO_CSA_DebounceReadAll = (void *)(GetProcAddress(hDLL, "DIO_CSA_DebounceReadAll"));
	if ( ! DIO_CSA_DebounceReadAll ) ProcStatus = ERROR_INVALID_FUNCTION;

	DAC_CSA_SetRangeLimits = (void *)(GetProcAddress(hDLL, "DAC_CSA_SetRangeLimits"));
	if ( ! DAC_CSA_SetRangeLimits ) ProcStatus = ERROR_INVALID_FUNCTION;
	DAC_CSA_ClearRangeLimits = (void *)(GetProcAddress(hDLL, "DAC_CSA_ClearRangeLimits"));
	if ( ! DAC_CSA_ClearRangeLimits ) ProcStatus = ERROR_INVALID_FUNCTION;

	DACDIO_WriteAll = (void *)(GetProcAddress(hDLL, "DACDIO_WriteAll"));
	if ( ! DACDIO_WriteAll ) ProcStatus = ERROR_INVALID_FUNCTION;



	DACDirect = (void *)(GetProcAddress(hDLL, "DACDirect"));
	if ( ! DACDirect ) ProcStatus = ERROR_INVALID_FUNCTION;
	DACMultiDirect = (void *)(GetProcAddress(hDLL, "DACMultiDirect"));
	if ( ! DACMultiDirect ) ProcStatus = ERROR_INVALID_FUNCTION;
	DACSetBoardRange = (void *)(GetProcAddress(hDLL, "DACSetBoardRange"));
	if ( ! DACSetBoardRange ) ProcStatus = ERROR_INVALID_FUNCTION;
	DACSetChannelCal = (void *)(GetProcAddress(hDLL, "DACSetChannelCal"));
	if ( ! DACSetChannelCal ) ProcStatus = ERROR_INVALID_FUNCTION;

	DACOutputProcess = (void *)(GetProcAddress(hDLL, "DACOutputProcess"));
	if ( ! DACOutputProcess ) ProcStatus = ERROR_INVALID_FUNCTION;

	DACOutputOpen = (void *)(GetProcAddress(hDLL, "DACOutputOpen"));
	if ( ! DACOutputOpen ) ProcStatus = ERROR_INVALID_FUNCTION;
	DACOutputClose = (void *)(GetProcAddress(hDLL, "DACOutputClose"));
	if ( ! DACOutputClose ) ProcStatus = ERROR_INVALID_FUNCTION;
	DACOutputCloseNoEnd = (void *)(GetProcAddress(hDLL, "DACOutputCloseNoEnd"));
	if ( ! DACOutputCloseNoEnd ) ProcStatus = ERROR_INVALID_FUNCTION;
	DACOutputFrame = (void *)(GetProcAddress(hDLL, "DACOutputFrame"));
	if ( ! DACOutputFrame ) ProcStatus = ERROR_INVALID_FUNCTION;
	DACOutputFrameRaw = (void *)(GetProcAddress(hDLL, "DACOutputFrameRaw"));
	if ( ! DACOutputFrameRaw ) ProcStatus = ERROR_INVALID_FUNCTION;
	DACOutputSetCount = (void *)(GetProcAddress(hDLL, "DACOutputSetCount"));
	if ( ! DACOutputSetCount ) ProcStatus = ERROR_INVALID_FUNCTION;
	DACOutputStart = (void *)(GetProcAddress(hDLL, "DACOutputStart"));
	if ( ! DACOutputStart ) ProcStatus = ERROR_INVALID_FUNCTION;
	DACOutputSetInterlock = (void *)(GetProcAddress(hDLL, "DACOutputSetInterlock"));
	if ( ! DACOutputSetInterlock ) ProcStatus = ERROR_INVALID_FUNCTION;
	DACOutputSetClock = (void *)(GetProcAddress(hDLL, "DACOutputSetClock"));
	if ( ! DACOutputSetClock ) ProcStatus = ERROR_INVALID_FUNCTION;

	SetLastError(ProcStatus);
	return ERROR_SUCCESS;
}

unsigned long AIOUSB_Unload(void)
{
	if ( ! hDLL ) return ERROR_NO_SUCH_MEMBER;

	GetDevices = NULL;
	QueryDeviceInfo = NULL;
	AIOUSB_CloseDevice = NULL;
	ClearDevices = NULL;
	GetDeviceUniqueStr = NULL;
	GetDeviceSerialNumber = NULL;
	ResolveDeviceIndex = NULL;
	GetDeviceByEEPROMByte = NULL;
	GetDeviceByEEPROMData = NULL;
	GetDeviceBySerialNumber = NULL;

	AIOUSB_ClearFIFO = NULL;
	AIOUSB_GetStreamStatus = NULL;
	AIOUSB_SetStreamingBlockSize = NULL;
	AIOUSB_ResetChip = NULL;
	AIOUSB_ReloadDeviceLinks = NULL;
	AIOUSB_UploadD15LoFirmwaresByPID = NULL;

	AIOUSB_QuerySimplePNPData = NULL;

	CustomEEPROMRead = NULL;
	CustomEEPROMWrite = NULL;
	AIOUSB_FlashRead = NULL;
	AIOUSB_FlashWrite = NULL;
	AIOUSB_FlashEraseSector = NULL;

	GenericVendorRead = NULL;
	GenericVendorWrite = NULL;
	AWU_GenericBulkIn = NULL;
	AWU_GenericBulkOut = NULL;



	ADC_GetScan = NULL;
	ADC_GetScanV = NULL;
	ADC_GetChannelV = NULL;
	ADC_GetCalRefV = NULL;

	ADC_GetTrigScan = NULL;
	ADC_GetTrigScanV = NULL;

	ADC_GetConfig = NULL;
	ADC_SetConfig = NULL;
	ADC_ADMode = NULL;
	ADC_Range1 = NULL;
	ADC_RangeAll = NULL;
	ADC_SetScanLimits = NULL;
	ADC_SetOversample = NULL;
	ADC_QueryCal = NULL;
	ADC_SetCal = NULL;
	ADC_SetCalAndSave = NULL;
	ADC_Initialize = NULL;
	ADC_GetImmediate = NULL;

	ADC_BulkAcquire = NULL;
	ADC_BulkPoll = NULL;
	ADC_BulkAbort = NULL;

	ADC_BulkMode = NULL;
	ADC_BulkContinuousCallbackStart = NULL;
	ADC_BulkContinuousCallbackStartClocked = NULL;
	ADC_BulkContinuousRingStart = NULL;
	ADC_BulkContinuousEnd = NULL;

	ADC_FullStartRing = NULL;
	ADC_ReadData = NULL;

	ADC_InitFastITScanV = NULL;
	ADC_ResetFastITScanV = NULL;
	ADC_SetFastITScanVChannels = NULL;
	ADC_GetFastITScanV = NULL;
	ADC_GetITScanV = NULL;

	ADC_InitFastScanV = NULL;
	ADC_ResetFastScanV = NULL;
	ADC_GetFastScanV = NULL;



	CTR_8254Load = NULL;
	CTR_8254Mode = NULL;
	CTR_8254ModeLoad = NULL;
	CTR_8254Read = NULL;
	CTR_8254ReadStatus = NULL;
	CTR_8254ReadModeLoad = NULL;

	CTR_StartOutputFreq = NULL;

	CTR_8254ReadAll = NULL;

	CTR_8254SelectGate = NULL;
	CTR_8254ReadLatched = NULL;
	CTR_SetWaitGates = NULL;
	CTR_EndWaitGates = NULL;
	CTR_WaitForGate = NULL;

	CTR_StartMeasuringPulseWidth = NULL;
	CTR_StopMeasuringPulseWidth = NULL;
	CTR_GetPulseWidthMeasurement = NULL;



	DIO_Configure = NULL;
	DIO_ConfigureEx = NULL;
	DIO_ConfigureMasked = NULL;
	DIO_ConfigurationQuery = NULL;

	DIO_Read1 = NULL;
	DIO_Read8 = NULL;
	DIO_ReadAll = NULL;

	DIO_Write1 = NULL;
	DIO_Write8 = NULL;
	DIO_WriteAll = NULL;



	DIO_StreamOpen = NULL;
	DIO_StreamClose = NULL;
	DIO_StreamFrame = NULL;
	DIO_StreamSetClocks = NULL;

	DIO_SPI_Read = NULL;
	DIO_SPI_Write = NULL;

	DIO_CSA_DoSync = NULL;
	DIO_CSA_DebounceSet = NULL;
	DIO_CSA_DebounceReadAll = NULL;

	DAC_CSA_SetRangeLimits = NULL;
	DAC_CSA_ClearRangeLimits = NULL;

	DACDIO_WriteAll = NULL;



	DACDirect = NULL;
	DACMultiDirect = NULL;
	DACSetBoardRange = NULL;
	DACSetChannelCal = NULL;

	DACOutputProcess = NULL;

	DACOutputOpen = NULL;
	DACOutputClose = NULL;
	DACOutputCloseNoEnd = NULL;
	DACOutputFrame = NULL;
	DACOutputFrameRaw = NULL;
	DACOutputSetCount = NULL;
	DACOutputStart = NULL;
	DACOutputSetInterlock = NULL;
	DACOutputSetClock = NULL;

	FreeLibrary(hDLL);
	hDLL = NULL;

	return ERROR_SUCCESS;
}

